//-	---------------------------------------------------------------------------
//-	Name: 		SDIGridCtl.cpp
//-
//-	Purpose:	This file provides the implementation of the class
//-				CSDIGridCtrl.
//-
//-	Revisions:
//-	Date		Author		Change Summary
//-	---------	------		---------------------------------------------------
//-	09-30-99	Mklombardi@ Created & Released.
//-             netzero,net 
//-
//-	Notes:		None.
//-
//- Copyright : This software is NOT copyrighted.
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in  this file is used in any commercial application 
// then acknowledgement must be made to the author of this file 
// (in whatever form you wish).
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.
//
// Expect bugs!
// 
// Please use and enjoy. Please let me know of any bugs/mods/improvements 
// that you have found/implemented and I will fix/incorporate them into this
// file. 
//
//-	---------------------------------------------------------------------------
// SDIGridCtl.cpp : Implementation of the CSDIGridCtrl ActiveX Control class.

#include "stdafx.h"
#include "SDIGrid.h"
#include "SDIGridCtl.h"
#include "SDIGridPpg.h"

#define Control_Size_X	250
#define Control_Size_Y	250
#define DefaultGridSize 5

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CSDIGridCtrl, COleControl)

/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CSDIGridCtrl, COleControl)
	//{{AFX_MSG_MAP(CSDIGridCtrl)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(OCM_COMMAND, OnOcmCommand)
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CSDIGridCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CSDIGridCtrl)
	DISP_PROPERTY_NOTIFY(CSDIGridCtrl, "NumRows", m_numRows, OnNumRowsChanged, VT_I2)
	DISP_PROPERTY_NOTIFY(CSDIGridCtrl, "NumCols", m_numCols, OnNumColsChanged, VT_I2)
	DISP_PROPERTY_NOTIFY(CSDIGridCtrl, "ColZeroIsFixed", m_colZeroIsFixed, OnColZeroIsFixedChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CSDIGridCtrl, "FixedColHeight", m_fixedColHeight, OnFixedColHeightChanged, VT_I2)
	DISP_FUNCTION(CSDIGridCtrl, "GetCellType", GetCellType, VT_I2, VTS_I2 VTS_I2)
	DISP_FUNCTION(CSDIGridCtrl, "GetCellContents", GetCellContents, VT_BSTR, VTS_I2 VTS_I2)
	DISP_FUNCTION(CSDIGridCtrl, "SetCellContents", SetCellContents, VT_EMPTY, VTS_I2 VTS_I2 VTS_BSTR)
	DISP_FUNCTION(CSDIGridCtrl, "GetAddress", GetAddress, VT_I4, VTS_NONE)
	DISP_FUNCTION(CSDIGridCtrl, "ClearGrid", ClearGrid, VT_EMPTY, VTS_NONE)
	DISP_STOCKPROP_READYSTATE()
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CSDIGridCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CSDIGridCtrl, COleControl)
	//{{AFX_EVENT_MAP(CSDIGridCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	EVENT_STOCK_READYSTATECHANGE()
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CSDIGridCtrl, 1)
	PROPPAGEID(CSDIGridPropPage::guid)
END_PROPPAGEIDS(CSDIGridCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CSDIGridCtrl, "SDIGRID.SDIGridCtrl.1",
	0xc3e95cf6, 0x64bc, 0x11d3, 0x8d, 0x9c, 0x4e, 0xe4, 0xb9, 0, 0, 0)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CSDIGridCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DSDIGrid =
		{ 0xc3e95cf4, 0x64bc, 0x11d3, { 0x8d, 0x9c, 0x4e, 0xe4, 0xb9, 0, 0, 0 } };
const IID BASED_CODE IID_DSDIGridEvents =
		{ 0xc3e95cf5, 0x64bc, 0x11d3, { 0x8d, 0x9c, 0x4e, 0xe4, 0xb9, 0, 0, 0 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwSDIGridOleMisc =
	OLEMISC_SIMPLEFRAME |
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CSDIGridCtrl, IDS_SDIGRID, _dwSDIGridOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::CSDIGridCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CSDIGridCtrl

BOOL CSDIGridCtrl::CSDIGridCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_SDIGRID,
			IDB_SDIGRID,
			afxRegInsertable | afxRegApartmentThreading,
			_dwSDIGridOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::CSDIGridCtrl - Constructor

CSDIGridCtrl::CSDIGridCtrl() : m_GridCtrl(DefaultGridSize, DefaultGridSize, 1, 1)
{
	InitializeIIDs(&IID_DSDIGrid, &IID_DSDIGridEvents);
	EnableSimpleFrame();
	m_lReadyState = READYSTATE_LOADING;
    m_GridCreated = FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::~CSDIGridCtrl - Destructor

CSDIGridCtrl::~CSDIGridCtrl()
{
    //Dont be a memory oink oink!
    CleanColumnHeadings();
    CleanRowHeadings();
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::OnDraw - Drawing function

void CSDIGridCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
    if (!m_GridCreated)
    {
        CreateGrid();
	}
	else if (GetSafeHwnd() != NULL)
	{
		m_GridCtrl.SendMessage(WM_PAINT, NULL, NULL);
        m_GridCtrl.SendMessage(WM_ERASEBKGND, 0);
        m_GridCtrl.SetRedraw(TRUE, TRUE);
		SendMessage(WM_ERASEBKGND, 0);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::DoPropExchange - Persistence support

void CSDIGridCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

    try
    {
	    //Call PX_ functions for each persistent custom property.
        PX_Bool (pPX, "ColZeroIsFixed", m_colZeroIsFixed, TRUE);
   	    PX_Short(pPX, "NumRows", m_numRows, DefaultGridSize);
        PX_Short(pPX, "NumCols", m_numCols, DefaultGridSize);
        PX_Short(pPX, "FixedColHeight", m_fixedColHeight, DefaultColHeight);

        //Get or store all of the column headings to the resource editor
        if (pPX->IsLoading())
        {
            CleanColumnHeadings();
            CleanRowHeadings();
        }

        for (int Index = 0; Index < m_numCols; Index++)
        {
            //if (Storing)
            if (!pPX->IsLoading())
            {
                POSITION CurrentPosition = m_ColHeadings.FindIndex(Index);
                if (CurrentPosition != NULL)
                {
                    CellDataType* pCellData = (CellDataType *)m_ColHeadings.GetAt(CurrentPosition);

                    //Save the data
                    if (pCellData != NULL)
                    {
                        char ascii[4];
                        CString Heading = _T("Column");
                        Heading += itoa(Index, ascii, 10);
                        Heading += _T("Id");
               	        PX_Short(pPX, Heading, pCellData->Id);

                        Heading = _T("Column");
                        Heading += itoa(Index, ascii, 10);
                        Heading += _T("CellType");
                        short Temp = pCellData->ItemType;
               	        PX_Short(pPX, Heading, Temp);

                        Heading = _T("Column");
                        Heading += itoa(Index, ascii, 10);
                        Heading += _T("Width");
               	        PX_Short(pPX, Heading, pCellData->ColWidth);

                        Heading = _T("Column");
                        Heading += itoa(Index, ascii, 10);
                        Heading += _T("Desc");
               	        PX_String(pPX, Heading, pCellData->Desc);

                        //Store all of the drop list items;
                        if (pCellData->ItemType == ListData)
                        {
                            //How many items in the drop list?
                            short NumItemsInList = pCellData->DropListItems.GetSize();

                            Heading = _T("Column");
                            Heading += itoa(Index, ascii, 10);
                            Heading += _T("NumDropListItems");
                   	        PX_Short(pPX, Heading, NumItemsInList);

                            //Lopp for all items in the drop list;
                            for (int DropListIndex = 0; DropListIndex < NumItemsInList; DropListIndex++)
                            {
                                Heading = _T("Column");
                                Heading += itoa(Index, ascii, 10);
                                Heading += _T("DropListItem");
                                Heading += itoa(DropListIndex, ascii, 10);
                                CString DropListItem = (CString)pCellData->DropListItems.GetAt(DropListIndex);
              	                PX_String(pPX, Heading, DropListItem);
                            } //for
                        } //Listdata
                    }
                }
            }
            else
            { //Loading
                CellDataType* pNewColumn = new CellDataType;

                //Initiaize new structure;
                pNewColumn->Id = Index;
                pNewColumn->ColWidth = DefaultColWidth;
                pNewColumn->ItemType = EditData;

                char ascii[4];
                CString Heading = _T("Column");
                Heading += itoa(Index, ascii, 10);
                Heading += _T("Id");
       	        PX_Short(pPX, Heading, pNewColumn->Id);

                Heading = _T("Column");
                Heading += itoa(Index, ascii, 10);
                Heading += _T("CellType");
                short Temp;
      	        PX_Short(pPX, Heading, Temp);
                pNewColumn->ItemType = (ItemDataType)Temp;

                Heading = _T("Column");
                Heading += itoa(Index, ascii, 10);
                Heading += _T("Width");
      	        PX_Short(pPX, Heading, pNewColumn->ColWidth);

                Heading = _T("Column");
                Heading += itoa(Index, ascii, 10);
                Heading += _T("Desc");
      	        PX_String(pPX, Heading, pNewColumn->Desc);

                //Store all of the drop list items;
                if (pNewColumn->ItemType == ListData)
                {
                    short NumItemsInList = 0;
                    Heading = _T("Column");
                    Heading += itoa(Index, ascii, 10);
                    Heading += _T("NumDropListItems");
                    PX_Short(pPX, Heading, NumItemsInList);

                    //Lopp for all items in the drop list;
                    for (int DropListIndex = 0; DropListIndex < NumItemsInList; DropListIndex++)
                    {
                        Heading = _T("Column");
                        Heading += itoa(Index, ascii, 10);
                        Heading += _T("DropListItem");
                        Heading += itoa(DropListIndex, ascii, 10);
                        CString DropListItem;
                        PX_String(pPX, Heading, DropListItem);
                        pNewColumn->DropListItems.Add(DropListItem);
                    } //for
                } //Listdata

                m_ColHeadings.AddTail((CObject *)pNewColumn);
            }
        } //for


        //Get or store all of the row headings to the resource editor
        for (Index = 0; Index < m_numRows; Index++)
        {
            //if (Storing)
            if (!pPX->IsLoading())
            {
                POSITION CurrentPosition = m_RowHeadings.FindIndex(Index);
                if (CurrentPosition != NULL)
                {
                    CellDataType* pCellData = (CellDataType *)m_RowHeadings.GetAt(CurrentPosition);

                    //Save the data
                    if (pCellData != NULL)
                    {
                        char ascii[4];
                        CString Heading = _T("Row");
                        Heading += itoa(Index, ascii, 10);
                        Heading += _T("Id");
               	        PX_Short(pPX, Heading, pCellData->Id);

                        Heading = _T("Row");
                        Heading += itoa(Index, ascii, 10);
                        Heading += _T("CellType");
                        short Temp = pCellData->ItemType;
               	        PX_Short(pPX, Heading, Temp);

                        Heading = _T("Row");
                        Heading += itoa(Index, ascii, 10);
                        Heading += _T("Desc");
               	        PX_String(pPX, Heading, pCellData->Desc);
                    }
                }
            }
            else
            { //Loading
                CellDataType* pNewRow = new CellDataType;

                char ascii[4];
                CString Heading = _T("Row");
                Heading += itoa(Index, ascii, 10);
                Heading += _T("Id");
       	        PX_Short(pPX, Heading, pNewRow->Id);

                Heading = _T("Row");
                Heading += itoa(Index, ascii, 10);
                Heading += _T("CellType");
                short Temp;
      	        PX_Short(pPX, Heading, Temp);
                pNewRow->ItemType = (ItemDataType)Temp;

                Heading = _T("Row");
                Heading += itoa(Index, ascii, 10);
                Heading += _T("Desc");
      	        PX_String(pPX, Heading, pNewRow->Desc);

                m_RowHeadings.AddTail((CObject *)pNewRow);
            }
        } //for

        if (pPX->IsLoading())
        {
            OnNumRowsChanged();
            OnNumColsChanged();
            OnColZeroIsFixedChanged();
            OnFixedColHeightChanged();
        }
    } //try

    catch(...)
    {
        TRACE("Exception loading/storing grid");
    }
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
// For information on using these flags, please see MFC technical note
// #nnn, "Optimizing an ActiveX Control".
DWORD CSDIGridCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();


	// The control can activate without creating a window.
	// TODO: when writing the control's message handlers, avoid using
	//		the m_hWnd member variable without first checking that its
	//		value is non-NULL.

  	dwFlags |= noFlickerActivate;

	return dwFlags;
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::OnResetState - Reset control to default state

void CSDIGridCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::AboutBox - Display an "About" box to the user

void CSDIGridCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_SDIGRID);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::PreCreateWindow - Modify parameters for CreateWindowEx

BOOL CSDIGridCtrl::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.lpszClass = _T("STATIC");
	return COleControl::PreCreateWindow(cs);
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::IsSubclassedControl - This is a subclassed control

BOOL CSDIGridCtrl::IsSubclassedControl()
{
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl::OnOcmCommand - Handle command messages

LRESULT CSDIGridCtrl::OnOcmCommand(WPARAM wParam, LPARAM lParam)
{
#ifdef _WIN32
	WORD wNotifyCode = HIWORD(wParam);
#else
	WORD wNotifyCode = HIWORD(lParam);
#endif

	// TODO: Switch on wNotifyCode here.

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CSDIGridCtrl message handlers

void CSDIGridCtrl::CreateGrid()
{
    m_GridCreated = TRUE;

    CRect rect(0,0,Control_Size_X, Control_Size_Y);
	if (GetSafeHwnd() != NULL)
		GetClientRect(&rect);

    //Create the grid;
    m_GridCtrl.Create(rect, this, IDC_GRID_CONTROL);

    //Set grid attributes;
   	m_GridCtrl.SetTextBkColor(RGB(0xFF, 0xFF, 0xE0));
   	m_GridCtrl.SetRowCount(m_numRows);
	m_GridCtrl.SetColumnCount(m_numCols);
    m_GridCtrl.SetFixedColumnCount(m_colZeroIsFixed);
    m_GridCtrl.SetRowHeight(0, m_fixedColHeight);

    //Set all the background and foreground colors of the cells;
    for (int ColIndex = 0; ColIndex < m_numCols; ColIndex++)
    {
        for (int RowIndex = 0; RowIndex < m_numRows; RowIndex++)
        {
            if ((RowIndex == 0) || ((ColIndex == 0) && (m_colZeroIsFixed)))
            {
                //Set row/col item colors;
                COLORREF clr = RGB(192,192,192);
                m_GridCtrl.SetItemBkColour(RowIndex, ColIndex, clr);
   				m_GridCtrl.SetItemFgColour(RowIndex, ColIndex, 0);  //Black, color of text
            }
            else
            {
                //Set cell items color;
                COLORREF clr	= RGB(255,255,200);
                m_GridCtrl.SetItemBkColour(RowIndex, ColIndex, clr);
   				m_GridCtrl.SetItemFgColour(RowIndex, ColIndex, 0);  //Black, color of text
            }
        }
    }


    //Set the column headings;
    DWORD dwTextStyle = DT_CENTER;
    for (int Index = 0; Index < m_numCols; Index++)
    {
        POSITION CurrentPosition = m_ColHeadings.FindIndex(Index);
        if (CurrentPosition != NULL)
        {
            CellDataType* pCellData = (CellDataType *)m_ColHeadings.GetAt(CurrentPosition);

            //Save the data
            if (pCellData != NULL)
            {
                //Set column heading;
                m_GridCtrl.SetItemText(0, Index, pCellData->Desc);

                //Set column width
                m_GridCtrl.SetColumnWidth(Index, pCellData->ColWidth);

    			GV_ITEM Item;
	    		Item.mask = GVIF_TEXT|GVIF_FORMAT;
		    	Item.row = 0;
			    Item.col = Index;
			
            	Item.nFormat = dwTextStyle;
				Item.szText = pCellData->Desc;
    			m_GridCtrl.SetItem(&Item);
                m_GridCtrl.SetItemState(0, Index, GVIS_READONLY);
            }

            //Create the cell types under this column
            if (pCellData->ItemType == ListData)
            {                                             
                for (int RowIndex = 1; RowIndex < m_numRows; RowIndex++)
                {
                    m_GridCtrl.CreateListCell(RowIndex, Index, pCellData->DropListItems);
                }
            }
            else if (pCellData->ItemType == CheckBoxData)
            {                                      
                for (int RowIndex = 1; RowIndex < m_numRows; RowIndex++)
                {
                    m_GridCtrl.CreateCheckCell(RowIndex, Index);
                }
            }
        }
    } //for


    //Set the row headings;
    for (Index = 0; Index < m_numRows; Index++)
    {
        POSITION CurrentPosition = m_RowHeadings.FindIndex(Index);
        if (CurrentPosition != NULL)
        {
            CellDataType* pCellData = (CellDataType *)m_RowHeadings.GetAt(CurrentPosition);

            //Save the data
            if (pCellData != NULL)
            {
                //Set row heading on the grid;
                if (m_colZeroIsFixed)
                {
                    m_GridCtrl.SetItemText(Index, 0, pCellData->Desc);

     			    GV_ITEM Item;
	    		    Item.mask = GVIF_TEXT|GVIF_FORMAT;
		    	    Item.row = Index;
			        Item.col = 0;
			    
            	    Item.nFormat = dwTextStyle;
				    Item.szText = pCellData->Desc;
    			    m_GridCtrl.SetItem(&Item);
                    m_GridCtrl.SetItemState(Index, 0, GVIS_READONLY);
                }
            }
        }
    } //for
}

void CSDIGridCtrl::OnNumRowsChanged() 
{
    //Set number of rows on the grid;
	m_GridCtrl.SetRowCount(m_numRows);
	SetModifiedFlag();
}

void CSDIGridCtrl::OnNumColsChanged() 
{
    //Set number of cols on the grid;
	m_GridCtrl.SetColumnCount(m_numCols);
	SetModifiedFlag();
}

void CSDIGridCtrl::OnColZeroIsFixedChanged() 
{
    //Tell Grid if col zero is fixed;
    if (m_colZeroIsFixed)
   	    m_GridCtrl.SetFixedColumnCount(1);
    else
        m_GridCtrl.SetFixedColumnCount(0);

	SetModifiedFlag();
}

CObList* CSDIGridCtrl::GetColHeadings()
{
    return &m_ColHeadings;
}

void CSDIGridCtrl::SetColHeadings()
{
    SetModifiedFlag();
}

CObList* CSDIGridCtrl::GetRowHeadings()
{
    return &m_RowHeadings;
}

void CSDIGridCtrl::SetRowHeadings()
{
    SetModifiedFlag();
}

void CSDIGridCtrl::CleanColumnHeadings()
{
    //Free any existing cell columns
	while (!m_ColHeadings.IsEmpty())
	{
		//Get the next element;
		CellDataType *pObject = (CellDataType *)m_ColHeadings.GetHead();

		//Delete the object pointer;
		m_ColHeadings.RemoveHead();

        //Remove any entries from the CStringArray element;
        pObject->DropListItems.RemoveAll();

		//Delete the object;
		delete pObject;
	}
}

void CSDIGridCtrl::CleanRowHeadings()
{
    //Free any existing cell columns
	while (!m_RowHeadings.IsEmpty())
	{
		//Get the next element;
		CellDataType *pObject = (CellDataType *)m_RowHeadings.GetHead();

		//Delete the object pointer;
		m_RowHeadings.RemoveHead();

        //Remove any entries from the CStringArray element;
        pObject->DropListItems.RemoveAll();

		//Delete the object;
		delete pObject;
	}
}

short CSDIGridCtrl::GetCellType(short nRow, short nCol) 
{
    ItemDataType CellType = m_GridCtrl.GetItemType(nRow, nCol);
	return CellType;
}

BSTR CSDIGridCtrl::GetCellContents(short Row, short Col) 
{
	CString strResult;

    //Determine the cell type;
    ItemDataType CellType = m_GridCtrl.GetItemType(Row, Col);

    if (CellType == EditData)
    {
        strResult = m_GridCtrl.GetItemText(Row, Col);
    }
    else if (CellType == CheckBoxData)
    {             
        strResult = m_GridCtrl.GetCheckBoxCellState(Row, Col);
    }
    else if (CellType == ListData)
    {
        strResult = m_GridCtrl.GetListCellData(Row, Col);
    }
	
    return strResult.AllocSysString();
}

void CSDIGridCtrl::SetCellContents(short Row, short Col, LPCTSTR Contents) 
{
    //Determine the cell type;
    ItemDataType CellType = m_GridCtrl.GetItemType(Row, Col);

    if (CellType == EditData)
    {
        //Do not set contents of column 0 if it is fixed;
        if ((Col != 0) || (!m_colZeroIsFixed))
            m_GridCtrl.SetItemText(Row, Col, Contents);
    }
    else if (CellType == CheckBoxData)
    {             
        //Save into CString;
        CString CheckContents = Contents;

        //if (Checked)
        if (CheckContents == YesString)
            m_GridCtrl.SetCheckBoxCellState(Row, Col, TRUE);
        else
            m_GridCtrl.SetCheckBoxCellState(Row, Col, FALSE);
    }
    else if (CellType == ListData)
    {
        m_GridCtrl.SetListCellData(Row, Col, Contents);
    }
}

long CSDIGridCtrl::GetAddress() 
{
    //This method allows property pages to invoke methods on our ActiveX control;
	long OurAddress = (long)this;
	return OurAddress;
}

short CSDIGridCtrl::GetNumRows()
{
    return m_numRows;
}

short CSDIGridCtrl::GetNumCols()
{
    return m_numCols;
}


void CSDIGridCtrl::ClearGrid() 
{
    //Tell Grid to clear any contents;
    m_GridCtrl.ClearGridContents();
}

void CSDIGridCtrl::OnFixedColHeightChanged() 
{
    //Set height for fixed columns;
    m_GridCtrl.SetRowHeight(0, m_fixedColHeight);
	SetModifiedFlag();
}

void CSDIGridCtrl::OnSize(UINT nType, int cx, int cy) 
{
	COleControl::OnSize(nType, cx, cy);
	
	m_GridCtrl.SetSize(cx, cy);
}
