//-	---------------------------------------------------------------------------
//-	Name: 		SetRowHeading.cpp
//-
//-	Purpose:	This file provides the implementation of the class
//-				CSetRowHeading.
//-
//-	Revisions:
//-	Date		Author		Change Summary
//-	---------	------		---------------------------------------------------
//-	09-30-99	Mklombardi@ Created & Released.
//-             netzero,net 
//-
//-	Notes:		None.
//-
//- Copyright : This software is NOT copyrighted.
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in  this file is used in any commercial application 
// then acknowledgement must be made to the author of this file 
// (in whatever form you wish).
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.
//
// Expect bugs!
// 
// Please use and enjoy. Please let me know of any bugs/mods/improvements 
// that you have found/implemented and I will fix/incorporate them into this
// file. 
//
//-	---------------------------------------------------------------------------
// SetRowHeading.cpp : implementation file
//

#include "stdafx.h"
#include "sdigrid.h"
#include "SetRowHeading.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetRowHeading dialog


CSetRowHeading::CSetRowHeading(CWnd* pParent /*=NULL*/)
	: CDialog(CSetRowHeading::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSetRowHeading)
	m_RowName = _T("");
	m_RowId = 0;
	//}}AFX_DATA_INIT
    m_NumRows = 0;
}


void CSetRowHeading::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetRowHeading)
	DDX_Control(pDX, IDC_ROW_NAME, m_RowCtl);
	DDX_Control(pDX, IDC_PREVIOUS_BUTTON, m_PreviousButton);
	DDX_Control(pDX, IDC_NEXT_BUTTON, m_NextButton);
	DDX_Text(pDX, IDC_ROW_NAME, m_RowName);
	DDX_Text(pDX, IDC_WHICH_ROW, m_RowId);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetRowHeading, CDialog)
	//{{AFX_MSG_MAP(CSetRowHeading)
	ON_BN_CLICKED(IDC_NEXT_BUTTON, OnNextButton)
	ON_BN_CLICKED(IDC_PREVIOUS_BUTTON, OnPreviousButton)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetRowHeading message handlers

BOOL CSetRowHeading::OnInitDialog() 
{
	CDialog::OnInitDialog();
    GetData();
    SetTimer(1223, 100, NULL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

CSetRowHeading::~CSetRowHeading()
{
}

void CSetRowHeading::GetData()
{
    POSITION CurrentPosition = m_pItems->FindIndex(m_RowId);
    if (CurrentPosition != NULL)
    {
        CellDataType* pCellData = (CellDataType *)m_pItems->GetAt(CurrentPosition);

        //if (New cell)
        if (pCellData == NULL)
        {
            m_RowName.Empty();
        }
        else                            
        {   //Extract existing record;
            m_RowName = pCellData->Desc;
        }
    }
    else
    {
        m_RowName.Empty();
    }
    UpdateData(FALSE);
}

void CSetRowHeading::StoreData()
{
    UpdateData(TRUE);

    CellDataType* pNewCellData;
    pNewCellData = new CellDataType;
    pNewCellData->Id = m_RowId;
    pNewCellData->Desc = m_RowName;
    pNewCellData->ItemType = EditData;

    POSITION CurrentPosition = m_pItems->FindIndex(m_RowId);
    if (CurrentPosition != NULL)
    {
        CellDataType* pCellData = (CellDataType *)m_pItems->GetAt(CurrentPosition);

        //if (New cell)
        if (pCellData == NULL)
        {
            m_pItems->AddTail((CObject *)pNewCellData);
        }
        else
        {   //Update existing record;
            pCellData->Desc = m_RowName;
            pCellData->ItemType = EditData;

            //Do not need new cell;
            delete pNewCellData;
        }
    }
    else
        m_pItems->AddTail((CObject *)pNewCellData);

    m_RowName.Empty();
}

void CSetRowHeading::OnNextButton() 
{
    StoreData();

	if (m_RowId == 0)
        m_PreviousButton.EnableWindow(TRUE);

    m_RowId++;

    if (m_RowId == m_NumRows-1)
        m_NextButton.EnableWindow(FALSE);

    GetData();
    SetTimer(223, 100, NULL);
}

void CSetRowHeading::OnPreviousButton() 
{    
    StoreData();

    if (m_RowId == m_NumRows-1)
        m_NextButton.EnableWindow(TRUE);

    m_RowId--;

	if (m_RowId == 0)
        m_PreviousButton.EnableWindow(FALSE);

    GetData();
    SetTimer(223, 100, NULL);
}

void CSetRowHeading::SetHeadings(CObList *pExistingItems)
{
    m_pItems = pExistingItems;
}

void CSetRowHeading::OnOK() 
{
    //Save latest;
	StoreData();
	CDialog::OnOK();
}

void CSetRowHeading::OnTimer(UINT nIDEvent) 
{
	KillTimer(nIDEvent);	
    m_RowCtl.SetFocus();
    CDialog::OnTimer(nIDEvent);
}
